#!/bin/bash
##########################################################################
# Script_Name : Change-Gdm-Background-2.0.sh                             # 
# Description : Change background image of the GDM Login screen          #
# on ubuntu 17.10 and later                                              #
# Date : November 2018                                                   #
# written by : Griffon                                                   #
# Web Site :http://www.c-nergy.be - http://www.c-nergy.be/blog           #    
# Version : 2.0                                                         #
# Disclaimer : Script provided AS IS. Use it at your own risk....        #
##########################################################################

#---------------------------------------------------#
# Script Version information Displayed              #
#---------------------------------------------------#

echo
/bin/echo -e "\e[1;36m   !-------------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;36m   !   Change-Gdm-Background script  - Ver 2.0                !\e[0m"
/bin/echo -e "\e[1;36m   !   Written by Griffon - November 2018 - www.c-nergy.be       !\e[0m"
/bin/echo -e "\e[1;36m   !-------------------------------------------------------------!\e[0m"
echo

#--------------------------------------------------------------------------#
# -----------------------Function Section - DO NOT MODIFY -----------------#
#--------------------------------------------------------------------------#

#--------------------------------------------------------------------#
# Function 1  - Update css file on Ubuntu 17.10,18.04                #
#--------------------------------------------------------------------#

ubuntu_css() 
{
echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! Check if script has been run already                   !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"

if [ -f /usr/share/gnome-shell/theme/ubuntu.css.griffon ]
then
sudo rm /usr/share/gnome-shell/theme/ubuntu.css
sudo mv /usr/share/gnome-shell/theme/ubuntu.css.griffon /usr/share/gnome-shell/theme/ubuntu.css
fi 
echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! Updating the ubuntu.css file....proceeding             !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"

sudo cp /usr/share/gnome-shell/theme/ubuntu.css /usr/share/gnome-shell/theme/ubuntu.css.griffon
sudo sed -i "/#lockDialogGroup/a  background: #2c001e url(file:///usr/share/backgrounds/${fname});\nbackground-repeat: no-repeat;\nbackground-size: cover;\nbackground-position: center;\n}\nByGriffon" /usr/share/gnome-shell/theme/ubuntu.css 
sudo sed -i '/ByGriffon/,+2d' /usr/share/gnome-shell/theme/ubuntu.css 

}

#--------------------------------------------------------------------#
# Function 2  - Update css file on Ubuntu 18.10                      #
#--------------------------------------------------------------------#

gdm_css()
{
echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! Check if script has been run already                   !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"

if [ -f /usr/share/gnome-shell/theme/Yaru/gnome-shell.css.griffon ]
then
sudo rm /usr/share/gnome-shell/theme/Yaru/gnome-shell.css
sudo mv /usr/share/gnome-shell/theme/Yaru/gnome-shell.css.griffon /usr/share/gnome-shell/theme/Yaru/gnome-shell.css
fi 

echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! Updating the gnome-shell.css file....proceeding        !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"

echo
sudo cp /usr/share/gnome-shell/theme/Yaru/gnome-shell.css /usr/share/gnome-shell/theme/Yaru/gnome-shell.css.griffon
sudo sed -i "/#lockDialogGroup/a  background: #2c001e url(file:///usr/share/backgrounds/${fname});\nbackground-repeat: no-repeat;\nbackground-size: cover;\nbackground-position: center;\n}\nByGriffon" /usr/share/gnome-shell/theme/Yaru/gnome-shell.css 
sudo sed -i '/ByGriffon/,+5d' /usr/share/gnome-shell/theme/Yaru/gnome-shell.css  
}

#---------------------------------------------------#
# Function 3  - Dialog Box select image...          #  
#---------------------------------------------------#

call_gui()
{
echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! Selecting an image...Proceeding                        !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
echo

pix=$(zenity --file-selection --title="select the new login image")

if [ $? -eq 1 ]
then
echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! No image selected...Quitting                           !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
echo
exit 
fi

# get just name of the file 
fname=$(basename $pix)

# Next Step - Copy file to correct location 

echo
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;32m   ! Copy image to correct location....proceeding           !\e[0m"
/bin/echo -e "\e[1;32m   !--------------------------------------------------------!\e[0m"
echo

sudo cp $pix /usr/share/backgrounds/

}


#--------------------------------------------------------------------------#
# -----------------------END Function Section             -----------------#
#--------------------------------------------------------------------------#


#--------------------------------------------------------------------------#
#------------                 MAIN SCRIPT SECTION       -------------------#  
#--------------------------------------------------------------------------#


#---------------------------------------------------#
#-- Step 0 - Try to Detect Ubuntu Version.... 
#---------------------------------------------------#

version=$(lsb_release -sd) 
codename=$(lsb_release -sc) 

echo
/bin/echo -e "\e[1;33m   |-| Detecting Ubuntu version        \e[0m"


if  [[ "$version" = *"Ubuntu 17.10"* ]];
then
/bin/echo -e "\e[1;32m       |-| Ubuntu Version : $version\e[0m"

call_gui
ubuntu_css

echo
elif [[ "$version" = *"Ubuntu 18.04"* ]];
then
/bin/echo -e "\e[1;32m       |-| Ubuntu Version : $version\e[0m"
echo
call_gui
ubuntu_css
elif [[ "$version" = *"Ubuntu 18.10"* ]];
then 
/bin/echo -e "\e[1;32m       |-| Ubuntu Version : $version\e[0m"
call_gui
gdm_css
echo
else
/bin/echo -e "\e[1;31m  !------------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;31m  ! Your system is not running Ubuntu 18.04 Edition and later  !\e[0m"
/bin/echo -e "\e[1;31m  ! The script has been tested only on Ubuntu 18.04 and later  !\e[0m"
/bin/echo -e "\e[1;31m  ! The script is exiting...                                   !\e[0m"              
/bin/echo -e "\e[1;31m  !------------------------------------------------------------!\e[0m"
echo
exit
fi


#---------------------------------------------------#
# Step 0 - Credits ....                             #        
#---------------------------------------------------#

/bin/echo -e "\e[1;36m   !--------------------------------------------------------!\e[0m"
/bin/echo -e "\e[1;36m   ! Change-Gdm-Background-2.0.sh                           !\e[0m"
/bin/echo -e "\e[1;36m   ! Version : 2.0 - November 2018                          !\e[0m"
/bin/echo -e "\e[1;36m   ! Written By - Griffon                                   !\e[0m"
/bin/echo -e "\e[1;36m   !                                                        !\e[0m"
/bin/echo -e "\e[1;36m   ! Web :www.c-nergy.be - www.c-nergy.be/blog              !\e[0m"
/bin/echo -e "\e[1;36m   !--------------------------------------------------------!\e[0m"
echo

#---------------------------------------------------#
# Step 4 - Ask User to reboot system 
#---------------------------------------------------#

echo
echo "Need to reboot your machine to see the changes....:-)"
echo 

zenity --info --title "Reboot needed" --text "A reboot of the machine is needed in order to apply the changes. Please Reboot your machine" --width=400

